#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "6legs.h"

extern  int data_port;
extern  int status_port;
extern  int controle_port;

extern	float leg_cooG[6][3];

/************************************************************************/
/*   A^CŃZbgŒړ郋[`@@@@@@@   */
//   悪ڒnĂ邩ǂ̃`FbNȂ
//   X^[gʒuleg_cooGƂ
//   ړڕW_ׂ͓Ăŋ
//   X^[gʒu܂܂ɏôŁAO̖͑{pӂ
/*   step     ..._̊Ԋu                    FPʂ͑S mm          */
/*   coo_dest[0] ...ړI_@w@                    @@@@@@ */
/*   coo_dest[1] ...ړI_@x@                    @@@@@@ */
/*   coo_dest[2] ...ړI_@y@                    @@@@@@ */
/*   leg_param      ...er̊􉽃p[^@@@@@@@@             */
//   leg_set        ...ǂ̑𓮂rbgp^[
//@@@@@@@@Ή@@P0ԋr@42ԋr@EEEE
/************************************************************************/
void move_2posD(float coo[3], float step, int leg_set, struct LEG_PARAM leg_param[6])
{
int		i,j,k,l,m,ch,ch1,mask0;
int     savo_data[3],devide;
float   coo_orbit[WAVE_MAX2][3],coo_orbit6[6][WAVE_MAX2][3];
float   a,dist[6],coo_dest[2][3],coo1[6];

//V̑邱ƂOƂĂ邪AG[H



//ëړ߂
   mask0 = 1;
   for(i = 0; i < 6; i++)
   {
      if((mask0 & leg_set) != 0)
      {
		  dist[i] = sqrt(
			  pow((coo[0] - leg_cooG[i][0]), 2) +
			  pow((coo[1] - leg_cooG[i][1]), 2) +
			  pow((coo[2] - leg_cooG[i][2]), 2)
			  );
	  }
	  else
		  dist[i] = 0.0;

      mask0 = mask0 * 2;
   }

//eʂ̃XebvvZ
	//Ԉړ̒߂
   k = 0;
   a = dist[0];
   for(i = 1; i < 6; i++)
   {
	   if(dist[i] > a)
	   {
		   a = dist[i];
		   k = i;
	   }
   }
   devide = (int)(a / step);

//eʂ̋OvZ
   mask0 = 1;
   for(i = 0; i < 6; i++)
   {
	   coo_dest[0][0] = leg_cooG[i][0];
	   coo_dest[0][1] = leg_cooG[i][1];
	   coo_dest[0][2] = leg_cooG[i][2];

	   coo_dest[1][0] = coo[0];
	   coo_dest[1][1] = coo[1];
	   coo_dest[1][2] = coo[2];

	   if((mask0 & leg_set) != 0)
      {
		 //eOɎۂ̃Xebv܂Ă邪ł͎̂ĂĂ
		 a = str_orbit4(coo_dest, devide, coo_orbit6[i]);
	  }
      mask0 = mask0 * 2;
   }

	for(k = 0; k < devide; k++)
	{
	   mask0 = 1;
	   for(i = 0; i < 6; i++)
	   {
	      if((mask0 & leg_set) != 0)
	      {
		     coo1[0] = leg_param[i].dx + coo_orbit6[i][k][0];
		     coo1[1] = leg_param[i].dy + coo_orbit6[i][k][1];
		     coo1[2] = leg_param[i].dz + coo_orbit6[i][k][2];

		     if(i == 0 || i == 1 || i == 2) legP_dcomv12(coo1, savo_data, leg_param[i], 0);
		     if(i == 3 || i == 4 || i == 5) legP_dcomv32(coo1, savo_data, leg_param[i], 0);

		     ch = i * 3;
		     ch1 = ch + 3;
		     j = 0;
		     for(l = ch; l < ch1; l++)
		     {
			     out_savo_Ap(savo_data[j], l);
		         j++;
		     }
		  }
	      mask0 = mask0 * 2;
	   }
	}

/*
	r̃}CNXCb`̃`FbNȂ̂
	^ꂽڕWlɂȂĂƉ肵đWO[o
	ϐԂB
*/
   mask0 = 1;
   for(i = 0; i < 6; i++)
   {
      if((mask0 & leg_set) != 0)
      {
	     for(j = 0; j < 3; j++)leg_cooG[i][j] = coo[j];
	  }
      mask0 = mask0 * 2;
   }
}

/************************************************************************/
/*   A^CŃZbgŐɒړ郋[`@@@*/
//   悪ڒnĂ邩ǂ̃`FbNȂ
/*   delta_z@...̑捂̑Έړ@@@@@@@                   @@@@@@ */
//   leg_set        ...ǂ̑𓮂rbgp^[
/*   leg_param      ...er̊􉽃p[^@@@@@@@@             */
//@@@@@@@@Ή@@P0ԋr@42ԋr@EEEE
//ӁF̃Tu[`͋OgȂ̂ňCɈړ鋗5mm炢܂
/************************************************************************/
void move_2pos_delta(float delta_z, int leg_set, struct LEG_PARAM leg_param[6])
{
int		i,j,k,l,m,ch,ch1,mask0;
int     savo_data[3];
float   coo[3];
	
	if(delta_z > 5.0 || delta_z < -5.0)
	{
		printf("ړstep̒l傫܂B\n");
		return;
	}

	mask0 = 1;
	for(i = 0; i < 6; i++)
	{
       if((mask0 & leg_set) != 0)
       {
	      coo[0] = leg_param[i].dx + leg_cooG[i][0];
	      coo[1] = leg_param[i].dy + leg_cooG[i][1];
	      coo[2] = leg_param[i].dz + leg_cooG[i][2] + delta_z;
	      leg_cooG[i][2] = leg_cooG[i][2] + delta_z;

	      if(i == 0 || i == 1 || i == 2) legP_dcomv12(coo, savo_data, leg_param[i], 0);
	      if(i == 3 || i == 4 || i == 5) legP_dcomv32(coo, savo_data, leg_param[i], 0);

	      ch = i * 3;
	      ch1 = ch + 3;
	      j = 0;
	      for(l = ch; l < ch1; l++)
	      {
		     out_savo_Ap(savo_data[j], l);
	         j++;
	      }
	   }
	   mask0 = mask0 * 2;
	}
}
/************************************************************************/
/*   A^CŃZbgŐɒړ郋[`@@@ */
//   悪ڒnĂ邩ǂ̃`FbNȂ
/*   delta_x@...̈ʒȗΈړ@@@@ @@@              */
//   leg_set        ...ǂ̑𓮂rbgp^[
/*   leg_param      ...er̊􉽃p[^@@@  @@@@             */
//@@@@@@@@Ή@@P0ԋr@42ԋr@EEEE
/************************************************************************/
void move_H_delta(float X, float dx, int leg_set, struct LEG_PARAM leg_param[6])
{
int		i,j,k,l,m,ch,ch1,mask0;
int     savo_data[3];
float   coo[3];
	
	//Ƃ肠͋rO֑ƂlȂ
	// X > 0 @dx < 0@ƂB
	while(X > 0)
	{
       X = X + dx;
	   mask0 = 1;
	   for(i = 0; i < 6; i++)
	   {
          if((mask0 & leg_set) != 0)
          {
	         leg_cooG[i][0] = leg_cooG[i][0] + dx;

		     coo[0] = leg_param[i].dx + leg_cooG[i][0];
	         coo[1] = leg_param[i].dy + leg_cooG[i][1];
	         coo[2] = leg_param[i].dz + leg_cooG[i][2];

	         if(i == 0 || i == 1 || i == 2) legP_dcomv12(coo, savo_data, leg_param[i], 0);
	         if(i == 3 || i == 4 || i == 5) legP_dcomv32(coo, savo_data, leg_param[i], 0);

	         ch = i * 3;
	         ch1 = ch + 3;
	         j = 0;
	         for(l = ch; l < ch1; l++)
	         {
		        out_savo_Ap(savo_data[j], l);
	            j++;
	         }
	      }
	      mask0 = mask0 * 2;
	   }
	}
}
