#include <stdio.h>
#include <math.h>

#include "6legs2.h"

/************************************************************************/
/**@R_̍WA炪\镽ʂ̖@xNg߂@@@  **/
/**  xNg(a1, b1, c1) , (a2, b2, c2)͐ڒn̑W(F0Ԃ
4ԁA2Ԃ4ԁj琶xNgB@xNg͂2{̃xNg
ƒBȂ킿ρOƂlŏoĂ**/
/**  ̃Tu[`͈ȉ̘A**/
/**  a1X + b1Y + c1Z = 0**/
/**  a2X + b2Y + c2Z = 0**/
//߂镽ʂ͌_܂(ʂ)ʁAԒ̔Cӂ̕ʂł͂Ȃ̂Œ
/************************************************************************/
void vector_to_plane(float coo[2][3], float vector[3])
{
float	a1,b1,c1,a2,b2,c2,D,E,x,y,z,l;

	//ɂČvZŉƂ̋Lɒ
	a1 = coo[0][0];
	b1 = coo[0][1];
	c1 = coo[0][2];
	a2 = coo[1][0];
	b2 = coo[1][1];
	c2 = coo[1][2];

	D = b1 / a1 - b2 / a2;
	E = c1 / a1 - c2 / a2;

	y = 1;
	z = - D / E * y;
	x = -(b1 / a1 - (c1 / a1) * (D / E)) * y;

	//vZʂPʃxNgɕϊ
	l = sqrt(pow(x, 2) + pow(y, 2) + pow(z, 2));

	vector[0] = x / l;
	vector[1] = y / l;
	vector[2] = z / l;
}


/************************************************************************/
/**@R̍Wߖ@ăXN[ɓe@@@@@@@  **/
/************************************************************************/
void dist_transf(float coo[WAVE_MAX][3], int data_num)
{
int     i;
float   x,y,dist_to_CRT = 400.0, rate;

/*dist_to_CRT...ώ@҂̖ڂXN[܂ł̋*/
/*W̒Pʂ mm*/

   for (i = 0; i < data_num; i++)
   {
     rate = dist_to_CRT / coo[i][2];
     coo[i][0] = coo[i][0] * rate;
     coo[i][1] = coo[i][1] * rate;
   }
}
/*******************************************************************/
/**  ]̂PϊŔCӂ̓_𒆐SɂĔCӂ̓_]       **/
/**  ]̒S͂y                                             **/
/**  coo[0][0] : x1  coo[0][1] : y1                               **/
/**  coo[1][0] : x2  coo[1][1] : y2                               **/
/**  canter_x, y : ]ϊ̒S@                               **/
/**  direction   : ]p@@@@@@                             **/
/**  data_num    : ]f[^                               **/
/**  @@cooɁAQz̐擪w|C^n              **/
/*******************************************************************/
void rotate_1DZ(float coo[WAVE_MAX][3], float center_x,
			float center_y, float direction, int data_num)
{
int     i;
float   x,y;

/* 󂯎WQ]̒S_ɗ悤ɕsړ */
   for (i = 0; i < data_num; i++)
   {
     coo[i][0] = coo[i][0] - center_x;
     coo[i][1] = coo[i][1] - center_y;
   }

/* _𒆐SƂĉ]̈ꎟϊ */
   for (i = 0; i < data_num; i++)
   {
     x = coo[i][0];
     y = coo[i][1];
     coo[i][0] = x * cos (direction) - y * sin (direction);
     coo[i][1] = x * sin (direction) + y * cos (direction);
   }

/* 󂯎WQ]̒S̈ʒuɗ悤ɕsړ߂ */
   for (i = 0; i < data_num; i++)
   {
     coo[i][0] = coo[i][0] + center_x;
     coo[i][1] = coo[i][1] + center_y;
   }
}
/*******************************************************************/
/**  ]̂PϊŔCӂ̓_𒆐SɂĔCӂ̓_]       **/
/**  ]̒S͂x                                             **/
/**  coo[0][0] : x1  coo[0][1] : y1                               **/
/**  coo[1][0] : x2  coo[1][1] : y2                               **/
/**  canter_x, y : ]ϊ̒S@                               **/
/**  direction   : ]p@@@@@@                             **/
/**  data_num    : ]f[^                               **/
/**  @@cooɁAQz̐擪w|C^n              **/
/*******************************************************************/
void rotate_1DY(float coo[WAVE_MAX][3], float center_x,
			float center_z, float direction, int data_num)
{
int     i;
float   x,z;

/* 󂯎WQ]̒S_ɗ悤ɕsړ */
   for (i = 0; i < data_num; i++)
   {
     coo[i][0] = coo[i][0] - center_x;
     coo[i][2] = coo[i][2] - center_z;
   }

/* _𒆐SƂĉ]̈ꎟϊ */
   for (i = 0; i < data_num; i++)
   {
     x = coo[i][0];
     z = coo[i][2];
     coo[i][0] = x * cos (direction) - z * sin (direction);
     coo[i][2] = x * sin (direction) + z * cos (direction);
   }

/* 󂯎WQ]̒S̈ʒuɗ悤ɕsړ߂ */
   for (i = 0; i < data_num; i++)
   {
     coo[i][0] = coo[i][0] + center_x;
     coo[i][2] = coo[i][2] + center_z;
   }
}
/******************************************************************/
/**  R̍W̔zϐ𕽍sړ̈ꎞϊ@          **/
/**  coo : vZxNg̍W@@@@@@@@@@          **/
/******************************************************************/
void palla_conv3D(float coo0[WAVE_MAX][3], float diff[1][3], int max_num, float dir)
{
int     i,j,k;

	for(i = 0; i < max_num; i++)
	{
	  coo0[i][0] = coo0[i][0] + diff[0][0] * dir;
	  coo0[i][1] = coo0[i][1] + diff[0][1] * dir;
	  coo0[i][2] = coo0[i][2] + diff[0][2] * dir;
	}
}
