#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "6legs.h"


/********************************************************************/
//		OXZʂɐ
//		num
//		step
//		r
//		start_q		0...A1...グ
//		coo         px90x270x̏ꏊ͕ԂȂ
/********************************************************************/
int str_orbit_circle1(int num, float step, float r, int start_q,
					  float coo[WAVE_MAX2][3])
{
int     i,j,k,l, end_coor0;
float   a,q;
float   step_q, PI;

	PI = 3.14159;
	step_q = PI / (int)(PI * r / step);

//	end_coor0 = (int)(PI * r / step) - 1;
	end_coor0 = (int)(PI * r / step);

	/*vZJnpx*/
//	q = step_q;
	q = 0.0;
	for(i = 1; i <= end_coor0; i++)
	{
	   if(start_q == 1)
	   {
	      coo[i][0] = - r * sin(q) + coo[0][0];
	      coo[i][1] = coo[0][1];
	      coo[i][2] = - r * cos(q) + r + (coo[0][2] - r);
	   }
	   else
	   {
		  coo[i][0] = r * sin(q) + coo[0][0];
	      coo[i][1] = coo[0][1];
	      coo[i][2] = r * cos(q) + r + (coo[0][2] - r);
	   }
       q = q + step_q;
	}

	//f[߂
	for(i = 1; i <= end_coor0; i++)
	{
	   for(j = 0; j < 3; j++)
	   {
		   coo[i - 1][j] = coo[i][j];
	   }
	}
	end_coor0--;

	return(end_coor0);
}
/************************************************************************/
/*   ړꍇɎg̋O̍W_쐬郋[`       */
/*   Ǒ`́A~`B悪ڒnĂ鎞ԂƁA󒆂̎ */
/*   ͂PFPɂȂĂB@@@@@@@@@@@                       */
/*   ̃Tu[`Ƃ͋OJn_̈ʒuقȂ                       */
/*   匳ł́AڒnJnʒułA͒ʒun܂B   */
/*   length   ...ړ                                      @       */
/*   hight    ...グ鍂i~̉~ʕ̒aj           */
/*   step     ..._̊Ԋu                    FPʂ͑S mm          */
/*   coo      ..._ij[g̈ʒuOiɓĂj */
/*   coo_pointer[0]...Lȓ_̌                                  */
/*   coo_pointer[1]...j[g̈ʒu                                */
/************************************************************************/

void str_orbit1(float length, float height, float step,
		float coo[WAVE_MAX2][3], int coo_pointer[10])
{
float   x,y,z,x0,y0,z0,x1,y1,z1,x2,y2,z2;
float   a,b,e,f,g,h,l2,m,o,p,q;
float   r,r0,r1,r2,r3;
float   coo0[WAVE_MAX2][3], coo1[WAVE_MAX2][3], coo_r0[30][3], coo_r1[30][3];
float   step2, step3, PI;
int     i,j,k,l,num_coo0, start_coo0, end_coo0, start_coor0, end_coor0;
int     num_coo1, start_coo1, end_coo1;
int     offx = 320, offy = 200, magni = 3;


	/*_͂wyŒ镽ʏɐB*/

	/* coo0 ... ڒnĒړԂ̓_ */
	/* coo1 ... 󒆂𒼐ړԂ̓_ */

	/* _length̊Ԃ؂钷łȂƍsȂ*/
	step2 = length / (int)(length / step);
	num_coo0 = (int)(length / step2);

	if(num_coo0 > WAVE_MAX2 / 2)
	{
	   printf("z񂪑܂BI܂Bstr_orbit1\n");
	   exit(0);
	}

	/*瓮n*/
	coo0[0][0] = 0.0 + step2 * num_coo0 / 2.0;   /* X */
	coo0[0][1] = 0.0;   /* Y */
	coo0[0][2] = 0.0;   /* Z */

	/*Oi*/
	start_coo0 = num_coo0 / 2.0;
	end_coo0 = num_coo0;
	for(i = 1; i <= num_coo0; i++)
	{
	   coo0[i][0] = coo0[i - 1][0] - step2;
	   coo0[i][1] = 0.0;
	   coo0[i][2] = 0.0;
	}

	/*ڒnԂ瑫̐U߂ɐ؂芷~*/
	r = height / 2.0;
	PI = 3.14159;
	//step = 5.0mm ɂċO@ςB
	//傫ȕŕƂagƑnʂɂXs[hȂ
	//ڂɃX[Y߁B
	a = (2 * PI * r + length) / num_coo0;
	if(step > 5.0) step3 = PI / (int)(PI * r / step);
	else step3 = PI / (int)(PI * r / a);
	q = step3;                              /*vZJnpx*/
	start_coor0 = 0;
	if(step > 5.0) end_coor0 = (int)(PI * r / step) - 1;
	else end_coor0 = (int)(PI * r / a) - 1;
	for(i = start_coor0; i <= end_coor0; i++)
	{
	   coo_r0[i][0] = - r * sin(q) + coo0[end_coo0][0];
	   coo_r0[i][1] = 0.0;
	   coo_r0[i][2] = - r * cos(q) + r;
	   q = q + step3;
	}


	/****************************************************/
	/****************************************************/
	/*󒆂Ŗ߂oH̓_B*/
	length = coo0[0][0] - coo0[end_coo0][0];
	step = end_coo0 - end_coor0 * 2 - 1;
	step2 = length / step;
	num_coo0 = step;

	coo1[0][0] = coo0[end_coo0][0];   /* X */
	coo1[0][1] = 0.0;                 /* Y */
	coo1[0][2] = height;              /* Z */

	start_coo1 = 0;
	end_coo1 = num_coo0;

	for(i = 1; i <= end_coo1; i++)
	{
	   coo1[i][0] = coo1[i - 1][0] + step2;
	   coo1[i][1] = 0.0;
	   coo1[i][2] = height;
	}

	/****************************************************/
	/*_̃~[*/
	q = step3;
	for(i = start_coor0; i <= end_coor0; i++)
	{
	   coo_r1[i][0] = r * sin(q) + coo1[end_coo1][0];
	   coo_r1[i][1] = 0.0;
	   coo_r1[i][2] = r * cos(q) + r;
	   q = q + step3;
	}

	/****************************************************/
	/****************************************************/


	/*ڒn(j[gʒu)*/
	j = 0;

	for(i = start_coo0 + 1; i <= end_coo0; i++)
	{
	   coo[j][0] = coo0[i][0];
	   coo[j][1] = coo0[i][1];
	   coo[j][2] = coo0[i][2];
	   j++;
	}

	/*U߂֐؂芷*/
	for(i = start_coor0; i < end_coor0; i++)
	{
	   coo[j][0] = coo_r0[i][0];
	   coo[j][1] = coo_r0[i][1];
	   coo[j][2] = coo_r0[i][2];
	   j++;
	}

	/*U߂*/
	for(i = start_coo1; i <= end_coo1; i++)
	{
	   coo[j][0] = coo1[i][0];
	   coo[j][1] = coo1[i][1];
	   coo[j][2] = coo1[i][2];
	   j++;
	}

	/*؂芷*/
	for(i = start_coor0; i < end_coor0; i++)
	{
	   coo[j][0] = coo_r1[i][0];
	   coo[j][1] = coo_r1[i][1];
	   coo[j][2] = coo_r1[i][2];
	   j++;
	}

	/*ڒnJnꏊ*/
	coo_pointer[1] = j;

	for(i = 0; i <= start_coo0; i++)
	{
	   coo[j][0] = coo0[i][0];
	   coo[j][1] = coo0[i][1];
	   coo[j][2] = coo0[i][2];
	   j++;
	}

	/*_̔z̍ől*/
	coo_pointer[0] = j - 1;

	/*j[gɈԋ߂ʒu*/
	coo_pointer[1] = j - coo_pointer[0] / 4;
}

/************************************************************************/
/*   𒼐ړ邽߂̍W_쐬郋[`@@@@       */
//   str_orbit4Ƃ͈̗^ႤA͂鋗mmԊu
//  邩^B
/*   step     ..._̊Ԋu                    FPʂ͑S mm          */
/*   coo_dest[0][0] ...ړJn_@w@                    @@@@@@ */
/*   coo_dest[0][1] ...ړJn_@x@                    @@@@@@ */
/*   coo_dest[0][2] ...ړJn_@y@                    @@@@@@ */
/*   coo_dest[1][0] ...ړI_@w@                    @@@@@@ */
/*   coo_dest[1][1] ...ړI_@x@                    @@@@@@ */
/*   coo_dest[1][2] ...ړI_@y@                    @@@@@@ */
/*   coo      ..._iړJn̈ʒuړIɓĂj */
/************************************************************************/

int str_orbit2(float coo_dest[2][3], float step, float coo[WAVE_MAX2][3])
{
int     i, j, k, l;
int     num_coo0;
float   dx0, dy0, dz0, vl, step2;
float   a,b,c;

	/*n_I_ɌAstep̃xNg߂*/
	dx0 = coo_dest[1][0] - coo_dest[0][0];
	dy0 = coo_dest[1][1] - coo_dest[0][1];
	dz0 = coo_dest[1][2] - coo_dest[0][2];

	a = dx0 * dx0 + dy0 * dy0 + dz0 * dz0;
	vl = sqrt( (double)a );

	/* _length̊Ԃ؂钷łȂƍsȂ*/
	step2 = vl / (int)(vl / step);
	num_coo0 = (int)(vl / step);

	dx0 = dx0 / (float)num_coo0;
	dy0 = dy0 / (float)num_coo0;
	dz0 = dz0 / (float)num_coo0;

	/*W_쐬*/
	coo[0][0] = coo_dest[0][0];
	coo[0][1] = coo_dest[0][1];
	coo[0][2] = coo_dest[0][2];

	for(i = 1; i < num_coo0; i++)
	{
	   coo[i][0] = coo[i - 1][0] + dx0;
	   coo[i][1] = coo[i - 1][1] + dy0;
	   coo[i][2] = coo[i - 1][2] + dz0;
	}

return(num_coo0);
}

/************************************************************************/
/*   ړꍇɎg̋O̍W_쐬郋[`       */
/*   Ǒ`́A`B悪ڒnĂ鎞ԂƁA󒆂̎ */
/*   ͂QFPɂȂĂB@@@@@@@@@@@                       */
/*   OJn_̈ʒúAʒuB                                     */
/*   length   ...ړ                                      @       */
/*   hight    ...グ鍂i~̉~ʕ̒aj           */
/*   step     ..._̊Ԋu                    FPʂ͑S mm          */
/*   coo      ..._ij[g̈ʒuOiɓĂj */
/*   coo_pointer[0]...Lȓ_̌                                  */
/*   coo_pointer[1]...j[g̈ʒu                                */
/************************************************************************/

void str_orbit3(float length, float height, int devide0,
		float coo[WAVE_MAX2][3], int coo_pointer[10], int rate)
{
float   x,y,z,x0,y0,z0,x1,y1,z1,x2,y2,z2;
float   a,b,e,f,g,h,l2,m,o,p,q;
float   r,r0,r1,r2,r3;
float   coo0[WAVE_MAX2][3], coo1[WAVE_MAX2][3], coo_r0[30][3], coo_r1[30][3];
float   step1,step2, step3;
int     i,j,k,l,num_coo0, num_coo1, num_coo2, start_coo0, end_coo0, start_coor0, end_coor0;
int     start_coo1, end_coo1, h_devide;
int     offx = 320, offy = 200, magni = 3;
float	coo_dest[2][3], devide;

	if(devide0 > WAVE_MAX2 / 2)
	{
	   printf("z񂪑܂BI܂Bstr_orbit1\n");
	   exit(0);
	}

	/*_͂wyŒ镽ʏɐB*/
	/* coo0 ... ڒnĒړԂ̓_ */
	/* coo1 ... 󒆂𒼐ړԂ̓_ */
	//coo_r0... グƂ̓_
	//coo_r1... Ƃ̓_

	/*Oi*/
	coo_dest[0][0] = length / 2;
	coo_dest[0][1] = 0.0;
	coo_dest[0][2] = 0.0;

	coo_dest[1][0] = - length / 2;
	coo_dest[1][1] = 0.0;
	coo_dest[1][2] = 0.0;

	step1 = str_orbit4(coo_dest, devide0, coo0);
	num_coo0 = devide0;
	start_coo0 = num_coo0 / 2;
	end_coo0 = num_coo0;

	/*グ钼*/
	coo_dest[0][0] = - length / 2;
	coo_dest[0][1] = 0.0;
	coo_dest[0][2] = 0.0;

	coo_dest[1][0] = - length / 2;
	coo_dest[1][1] = 0.0;
	coo_dest[1][2] = height;

	//15mmɑグ鍂܂Ă̂ŁA͂ЂƂ܂
	//3ƂĂ(height=155mmA206.6mm)
//	h_devide = (int)(height / 2.5);
	h_devide = (int)(((float)devide0 * (height * 2) / (length + height * 2.0)) / 2.0);
	step2 = str_orbit4(coo_dest, h_devide, coo_r0);

	/****************************************************/
	/****************************************************/
	/*󒆂Ŗ߂oH̓_B*/
	num_coo1 = num_coo0 / rate - (h_devide * 2);

	coo_dest[0][0] = - length / 2;
	coo_dest[0][1] = 0.0;
	coo_dest[0][2] = height;

	coo_dest[1][0] = length / 2;
	coo_dest[1][1] = 0.0;
	coo_dest[1][2] = height;

	step3 = str_orbit4(coo_dest, num_coo1, coo1);
	/****************************************************/
	//낷
	coo_dest[0][0] = length / 2;
	coo_dest[0][1] = 0.0;
	coo_dest[0][2] = height;

	coo_dest[1][0] = length / 2;
	coo_dest[1][1] = 0.0;
	coo_dest[1][2] = 0.0;

	//15mmɑグ鍂܂Ă̂ŁA͂ЂƂ܂
	//3ƂĂ(height=155mmA206.6mm)
	step2 = str_orbit4(coo_dest, h_devide, coo_r1);

	/********************************************************************/
	/********************************************************************/
	/********************************************************************/
	//߂l̔zɌvZʂZbg

	/*ڒn(j[gʒu)*/
	j = 0;

	for(i = start_coo0 + 1; i < end_coo0; i++)
	{
	   coo[j][0] = coo0[i][0];
	   coo[j][1] = coo0[i][1];
	   coo[j][2] = coo0[i][2];
	   j++;
	}

	/*U߂֐؂芷*/
	for(i = 0; i < h_devide; i++)
	{
	   coo[j][0] = coo_r0[i][0];
	   coo[j][1] = coo_r0[i][1];
	   coo[j][2] = coo_r0[i][2];
	   j++;
	}

	/*U߂*/
	for(i = 0; i < num_coo1; i++)
	{
	   coo[j][0] = coo1[i][0];
	   coo[j][1] = coo1[i][1];
	   coo[j][2] = coo1[i][2];
	   j++;
	}

	/*؂芷*/
	for(i = 0; i < h_devide; i++)
	{
	   coo[j][0] = coo_r1[i][0];
	   coo[j][1] = coo_r1[i][1];
	   coo[j][2] = coo_r1[i][2];
	   j++;
	}

	/*ڒnJnꏊ*/
	coo_pointer[1] = j;

	for(i = 0; i <= start_coo0; i++)
	{
	   coo[j][0] = coo0[i][0];
	   coo[j][1] = coo0[i][1];
	   coo[j][2] = coo0[i][2];
	   j++;
	}

	/*_̔z̍ől*/
	coo_pointer[0] = j - 1;

	/*j[gɈԋ߂ʒu*/
	coo_pointer[1] = j - coo_pointer[0] / 4;
}


/************************************************************************/
/*   𒼐ړ邽߂̍W_쐬郋[`@@@@       */
//   str_orbit2Ƃ͈̗^ႤA͂鋗邩
//   ^B
/*   devide         ...ԕ@@@@@@@@@@@@@@@@@@   */
/*   coo_dest[0][0] ...ړJn_@w@                    @@@@@@ */
/*   coo_dest[0][1] ...ړJn_@x@                    @@@@@@ */
/*   coo_dest[0][2] ...ړJn_@y@                    @@@@@@ */
/*   coo_dest[1][0] ...ړI_@w@                    @@@@@@ */
/*   coo_dest[1][1] ...ړI_@x@                    @@@@@@ */
/*   coo_dest[1][2] ...ړI_@y@                    @@@@@@ */
/*   coo      ..._iړJn̈ʒuړIɓĂj */
/*   step2     ..._̊Ԋu                    FPʂ͑S mm          */
/************************************************************************/
float str_orbit4(float coo_dest[2][3], int devide, float coo[WAVE_MAX2][3])
{
int     i, j, k, l;
int     num_coo0;
float   dx0, dy0, dz0, vl, step2;

	/*n_I_ɌAstep̃xNg߂*/
	dx0 = coo_dest[1][0] - coo_dest[0][0];
	dy0 = coo_dest[1][1] - coo_dest[0][1];
	dz0 = coo_dest[1][2] - coo_dest[0][2];

	vl = sqrt(pow(dx0 ,2) + pow(dy0 ,2) + pow(dz0 ,2));

	/* _length̊Ԃ؂钷łȂƍsȂ*/
	step2 = vl / (float)devide;

	dx0 = dx0 / (float)devide;
	dy0 = dy0 / (float)devide;
	dz0 = dz0 / (float)devide;

	/*W_쐬*/
	coo[0][0] = coo_dest[0][0];
	coo[0][1] = coo_dest[0][1];
	coo[0][2] = coo_dest[0][2];

	for(i = 1; i < devide; i++)
	{
	   coo[i][0] = coo[i - 1][0] + dx0;
	   coo[i][1] = coo[i - 1][1] + dy0;
	   coo[i][2] = coo[i - 1][2] + dz0;
	}

return(step2);
}

/************************************************************************/
/*   𒼐ړ邽߂̍W_쐬郋[`@@@@       */
//   _̊Ԋu(x̉)ɂȂĂB
/*   step_S         ...ړJn̓_̊Ԋu     FPʂ͑S mm       */
/*   step_E         ...ړI̓_̊Ԋu   @@@@@@@@          */
/*   coo_dest[0][0] ...ړJn_@w@                    @@@@@@ */
/*   coo_dest[0][1] ...ړJn_@x@                    @@@@@@ */
/*   coo_dest[0][2] ...ړJn_@y@                    @@@@@@ */
/*   coo_dest[1][0] ...ړI_@w@                    @@@@@@ */
/*   coo_dest[1][1] ...ړI_@x@                    @@@@@@ */
/*   coo_dest[1][2] ...ړI_@y@                    @@@@@@ */
/*   coo      ..._iړJn̈ʒuړIɓĂj */
/************************************************************************/

int str_orbit5(float coo_dest[2][3], float step_S, float step_E, float coo[WAVE_MAX2][3])
{
int     i, j, k, l;
int     num_coo0;
float   dx0, dy0, dz0, dx1, dy1, dz1, dx2, dy2, dz2;
float	vl, vl2, step2;
float   a,b,c,num_coof1;

	/*n_I_ɌPʃxNg߂*/
	dx0 = coo_dest[1][0] - coo_dest[0][0];
	dy0 = coo_dest[1][1] - coo_dest[0][1];
	dz0 = coo_dest[1][2] - coo_dest[0][2];

//	a = dx0 * dx0 + dy0 * dy0 + dz0 * dz0;
	//nI_Ԃ̋߂
	vl = sqrt( (double)(dx0 * dx0 + dy0 * dy0 + dz0 * dz0) );

	//_̐
	num_coof1 = (int)(vl * 2.0 /(step_S + step_E));
	//
	vl2 = (vl * 2 / num_coof1 - 2 * step_S) / (num_coof1 - 1);

	//Pʒɂ
	dx0 = dx0 / vl;
	dy0 = dy0 / vl;
	dz0 = dz0 / vl;

	//ړJn_̃xNg
	dx1 = dx0 * step_S;
	dy1 = dy0 * step_S;
	dz1 = dz0 * step_S;

	//eXebvƂ̕ω
	dx2 = dx0 * vl2;
	dy2 = dy0 * vl2;
	dz2 = dz0 * vl2;

	//*******************************************
	step2 = vl / step_S;

	/*W_쐬*/
	coo[0][0] = coo_dest[0][0];
	coo[0][1] = coo_dest[0][1];
	coo[0][2] = coo_dest[0][2];

	num_coo0 = (int)num_coof1;
	for(i = 1; i < num_coo0; i++)
	{
	   coo[i][0] = coo[i - 1][0] + dx1;
	   coo[i][1] = coo[i - 1][1] + dy1;
	   coo[i][2] = coo[i - 1][2] + dz1;

	   dx1 = dx1 + dx2;
	   dy1 = dy1 + dy2;
	   dz1 = dz1 + dz2;
	}

return(num_coo0);
}
