#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "6legs.h"

extern  int data_port;
extern  int status_port;
extern  int controle_port;

extern	float leg_cooG[6][3];
/***********************************************************************/
/*		X				Ẍړ                                */
/*		Y				Ÿړ                                */
/*		height			グ鍂                           */
/*		leg_bottom		ڒn                                       */
/*		step			𓮂                                 */
/*		leg_param		ep[[^[                             */
/***********************************************************************/
void move_adjust_strait0(float X, float Y, float height, float leg_bottom,
					   float step, struct  LEG_PARAM leg_param[6])
{
int     i,i2,j,k,m,n,num,leg_set,leg_set0,leg_set1,cycle;
float   coo[2][3],coo_dest[2][3];
float	a,dl1,dx,dy;

	//̃Tu[`6ڒnԂŃX^[ĝő낦
	adjust_hight(leg_bottom, 1, leg_param);

	leg_set0 = 21;
	leg_set1 = 42;

	num = (int)(sqrt(X * X + Y * Y) / step);
	dx = - X / (float)num;
	dy = - Y / (float)num;

	cycle = 15.0 / step;

	k = 0;
	for(i = 0; i < num; i++)
	{
		set_all_legs(leg_cooG[0][0] + dx, leg_cooG[0][1] + dy,leg_cooG[0][2], leg_param);
		k++;
		//xɒłpx̏𒴂x낦B
		if(k > cycle)
		{
			k = 0;
			move_2pos_up1(height, leg_bottom, 1.5, 21, leg_param);
			//Vrj[gʒuɈړ
			set_each_legs( 0.0, 0.0, height, 21,leg_param);
			//B(Vr؂ւ)
			move_2pos_down2(leg_bottom, 1.5, 21, leg_param);


			move_2pos_up1(height, leg_bottom, 1.5, 42, leg_param);
			//Vrj[gʒuɈړ
			set_each_legs( 0.0, 0.0, height, 42, leg_param);
			//B(Vr؂ւ)
			move_2pos_down2(leg_bottom, 1.5, 42, leg_param);
		}
	}

	if(k != 0)
	{
	   move_2pos_up1(height, leg_bottom, 1.5, 21, leg_param);
	   //Vrj[gʒuɈړ
	   set_each_legs( 0.0, 0.0, height, 21,leg_param);
	   //B(Vr؂ւ)
	   move_2pos_down2(leg_bottom, 1.5, 21, leg_param);

	   move_2pos_up1(height, leg_bottom, 1.5, 42, leg_param);
	   //Vrj[gʒuɈړ
	   set_each_legs( 0.0, 0.0, height, 42, leg_param);
	   //B(Vr؂ւ)
	   move_2pos_down2(leg_bottom, 1.5, 42, leg_param);
	}
	
}
/***********************************************************************/
/*		height			グ鍂                           */
/*		leg_param		ep[[^[                             */
/***********************************************************************/
void move_adjust_turn1(float CX, float CY, float height, float leg_bottom,
					   float Q, float dq, struct  LEG_PARAM leg_param[6])
{
int     i,i2,j,k,m,n,num,leg_set,leg_set0,leg_set1,cycle;
float   coo[2][3],coo_dest[2][3];
float	a,dl1,dx,dy;

	leg_set0 = 21;
	leg_set1 = 42;
	cycle = (int)(dq / 0.01);

	//250.0EEE{bg̒SZT[܂ł̋
	//80.0EEET̂߂Ɉړ
	//j = (int)(a * (250.0 / 80.0) / 0.01);
	j = Q / 0.01;
	k = 0;
	for(i = 0; i < abs(j); i++)
	{
	    //1p[^̓WA
		//̃Tu[`͕⊮ȂŃ_CNgɓ̂Œӂ̂
		if(j > 0)
		   move_adjust_turn0(CX, CY, -0.01, 255, leg_param);
		else
		   move_adjust_turn0(CX, CY, 0.01, 255, leg_param);

		k++;
		//xɒłpx̏𒴂x낦B
		if(k > cycle)
		{
			k = 0;
			move_2pos_up1(height, leg_bottom, 1.5, 21, leg_param);
			//Vrj[gʒuɈړ
			set_each_legs( 0.0, 0.0, height, 21,leg_param);
			//B(Vr؂ւ)
			move_2pos_down2(leg_bottom, 1.5, 21, leg_param);


			move_2pos_up1(height, leg_bottom, 1.5, 42, leg_param);
			//Vrj[gʒuɈړ
			set_each_legs( 0.0, 0.0, height, 42, leg_param);
			//B(Vr؂ւ)
			move_2pos_down2(leg_bottom, 1.5, 42, leg_param);
		}
	}

	if(k != 0)
	{
	   move_2pos_up1(height, leg_bottom, 1.5, 21, leg_param);
	   //Vrj[gʒuɈړ
	   set_each_legs( 0.0, 0.0, height, 21,leg_param);
	   //B(Vr؂ւ)
	   move_2pos_down2(leg_bottom, 1.5, 21, leg_param);

	   move_2pos_up1(height, leg_bottom, 1.5, 42, leg_param);
	   //Vrj[gʒuɈړ
	   set_each_legs( 0.0, 0.0, height, 42, leg_param);
	   //B(Vr؂ւ)
	   move_2pos_down2(leg_bottom, 1.5, 42, leg_param);
	}
	
}
/***********************************************************************/
/*		height			グ鍂                           */
/*		leg_param		ep[[^[                             */
//		cmd				0...[hNAX̌㌳̏Ԃɖ߂
//						1...[hNAX̌6ڒn̂܂
/***********************************************************************/
void adjust_hight(float height, int cmd, struct  LEG_PARAM leg_param[6])
{
int     i,i2,j,k,m,n,num,leg_set,leg_set0,leg_set1,cycle;
float   coo[2][3],coo_dest[2][3];
float	a,dl1,dx,dy;

	leg_set0 = 21;
	leg_set1 = 42;

	if(leg_cooG[0][2] == leg_cooG[2][2] && leg_cooG[0][2] == leg_cooG[4][2])
	{
	   if(leg_cooG[1][2] == leg_cooG[3][2] && leg_cooG[1][2] == leg_cooG[5][2])
	   {
		   if(leg_cooG[0][2] < leg_cooG[1][2])
		   {
		      printf("leg_set0ڒn(adjust_hight)\n");
			  if(cmd == 1)
			  {
				  //Vrj[gʒuɈړ
				  set_each_legs( 0.0, 0.0, leg_cooG[1][2], leg_set1,leg_param);
				  //B(Vr؂ւ)
				  move_2pos_down2(leg_cooG[0][2], 1.5, leg_set1, leg_param);

				  move_2pos_up1(leg_cooG[1][2], leg_cooG[0][2], 1.5, leg_set0, leg_param);
				  //Vrj[gʒuɈړ
				  set_each_legs( 0.0, 0.0, leg_cooG[1][2], leg_set0, leg_param);
				  //B(Vr؂ւ)
				  move_2pos_down2(leg_cooG[0][2], 1.5, leg_set0, leg_param);

				  //
			      coo_dest[0][0] = 0.0;
			      coo_dest[0][1] = 0.0;
			      coo_dest[0][2] = leg_cooG[0][2];

			      coo_dest[1][0] = 0.0;
			      coo_dest[1][1] = 0.0;
			      coo_dest[1][2] = height;
			      move_2pos1(coo_dest, 1.5, 255, leg_param);
			  }
		   }
		   if(leg_cooG[0][2] > leg_cooG[1][2])
		   {
		      printf("leg_set1ڒn(adjust_hight)\n");
			  if(cmd == 1)
			  {
				  //Vrj[gʒuɈړ
				  set_each_legs( 0.0, 0.0, leg_cooG[1][2], leg_set0,leg_param);
				  //B(Vr؂ւ)
				  move_2pos_down2(leg_cooG[0][2], 1.5, leg_set0, leg_param);

				  move_2pos_up1(leg_cooG[1][2], leg_cooG[0][2], 1.5, leg_set1, leg_param);
				  //Vrj[gʒuɈړ
				  set_each_legs( 0.0, 0.0, leg_cooG[1][2], leg_set1, leg_param);
				  //B(Vr؂ւ)
				  move_2pos_down2(leg_cooG[0][2], 1.5, leg_set1, leg_param);

				  //
			      coo_dest[0][0] = 0.0;
			      coo_dest[0][1] = 0.0;
			      coo_dest[0][2] = leg_cooG[0][2];

			      coo_dest[1][0] = 0.0;
			      coo_dest[1][1] = 0.0;
			      coo_dest[1][2] = height;
			      move_2pos1(coo_dest, 1.5, 255, leg_param);
			  }
		   }
		   if(leg_cooG[0][2] == leg_cooG[1][2])
		   {
			  //̏łcmdɊ֌WȂĂ܂Ȃ
		      printf("6ׂĐڒn(adjust_hight)\n");
			  coo_dest[0][0] = 0.0;
			  coo_dest[0][1] = 0.0;
			  coo_dest[0][2] = leg_cooG[0][2];

			  coo_dest[1][0] = 0.0;
			  coo_dest[1][1] = 0.0;
			  coo_dest[1][2] = height;
			  move_2pos1(coo_dest, 1.5, 255, leg_param);
		   }
	   }
	}
}
